using System;
using System.Collections.Generic;
using System.Text;
using System.Messaging;

namespace NServiceBus.Unicast.MsmqDistributor
{
    public class MsmqSubscriberManager
    {
        public MsmqSubscriberManager(string storageQueue)
        {
            MessageQueue q = new MessageQueue(storageQueue);

            if (!q.Transactional)
                throw new Exception("Queue must be transactional.");

            this.storageQueue = q;
        }

        private MessageQueue storageQueue;

        #region subscription management

        public void AddSubscriber(string path)
        {
            lock (locker)
            {
                Message msg = new Message();
                msg.ResponseQueue = new MessageQueue(path);

                this.storageQueue.Send(msg, MessageQueueTransactionType.Automatic);
            }
        }

        public string PopSubscriber()
        {
            lock (locker)
            {
                Message[] existing = this.storageQueue.GetAllMessages();

                if (existing.Length == 0)
                    return null;
                else
                {
                    string path = existing[0].ResponseQueue.Path;

                    Message m = this.storageQueue.ReceiveById(existing[0].Id, MessageQueueTransactionType.Automatic);

                    return path;
                }
            }
        }

        private object locker = new object();

        #endregion
    }
}
